
<?php
/* 
WordPress optimization specialist = RankYa
Automatically inserts social media share links to blog posts, after content area.
Simply insert the code in wp-content > themes > yourCurrentTheme > functions.php
*/


function rankya_social_share_buttons($content) {
	$siteurlfromsettingsgeneral =  get_bloginfo( 'url' );
    $domainparts = parse_url($siteurlfromsettingsgeneral);
    $domain = isset($domainparts['host']) ? $domainparts['host'] : '';
        if (preg_match('/(?P<domain>[a-z0-9][a-z0-9-]{1,63}\.[a-z\.]{2,6})$/i', $domain, $regs)) {
       $siteurlfromsettingsgeneral = strstr( $regs['domain'], '.', true );
    }
    if(is_single()){ //if you want you can replace is_single with is_singular()
        $rankya_url = urlencode( get_permalink() );
        $rankya_title = str_replace( ' ', '%20', get_the_title()); 
        $twitterURL = 'https://x.com/intent/post?text='.$rankya_title.'&amp;url='.$rankya_url.'&amp;via='.$siteurlfromsettingsgeneral.'';
        $facebookURL = 'https://www.facebook.com/sharer/sharer.php?u='.$rankya_url;
        $linkedInURL = 'https://www.linkedin.com/shareArticle?mini=true&url='.$rankya_url.'&amp;title='.$rankya_title;
		$redditURL = 'https://www.reddit.com/submit?url='.$rankya_url.'&amp;title='.$rankya_title;
		if ( has_post_thumbnail() ) {
					$thumb_id = get_post_thumbnail_id();
					$thumb_url = wp_get_attachment_image_src($thumb_id,'full', true); 
					$pinterestNewURL = 'https://pinterest.com/pin/create/button/?url='.$rankya_url.'&amp;media='.$thumb_url[0].'&amp;description='.$rankya_title;
		} else{
			$pinterestNewURL = 'https://pinterest.com/pin/create/button/?url='.$rankya_url.'&amp;description='.$rankya_title;
			}
				$content .= '<div class="social-share-div"><p class="rankyaspecialbackground">Please do support us by sharing this content.</p><div class="share-buttons"> <a class="buttonlink share-button-profile-facebook" href="'.$facebookURL.'" target="_blank" rel="nofollow noopener">Facebook</a> <a class="buttonlink share-button-profile-x" href="'. $twitterURL .'" target="_blank" rel="nofollow noopener">X</a> <a class="buttonlink share-button-profile-linkedin" href="'.$linkedInURL.'" target="_blank" rel="nofollow noopener">LinkedIn</a> <a class="buttonlink share-button-profile-pinterest" href="'.$pinterestNewURL.'" data-pin-custom="true" target="_blank" rel="nofollow noopener">Pin It</a> <a class="buttonlink share-button-profile-reddit" href="'.$redditURL.'" target="_blank" rel="nofollow noopener">Reddit</a></div></div>';
        return $content;
    } else {
        return $content;
    }
};
add_filter( 'the_content', 'rankya_social_share_buttons');
